Subject: Re: [PATCHv2] serial: mxs-auart: fix probe error paths and clock handling

From: Greg Kroah-Hartman <[email-masked]>
Date: Sun, 31 May 2026 09:51:56 +0200

On Sat, May 30, 2026 at 12:55:03PM -0700, Rosen Penev wrote:
> Sashiko reported three pre-existing bugs in the mxs-auart driver:
> 
> - For non-ASM9260 variants, mxs_get_clks() obtained the clock but never
>   prepared/enabled it, leaving register accesses in probe at risk of
>   faulting if the bootloader had gated the clock.
> - The error path and remove function used pdev->id instead of
>   s->port.line to clear the auart_port[] slot.  For DT-probed devices
>   pdev->id is -1, causing an out-of-bounds write and leaving a dangling
>   pointer in the array.
> - The probe error path called iounmap() while the IRQ was still
>   registered. An interrupt during that window would dereference the
>   unmapped membase.

This should still be broken up into smaller pieces, don't you think?

Whenever you have to list the different things you do in a patch, that's
a huge hint to do so.

thanks,

greg k-h